"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __require = typeof require !== "undefined" ? require : (x) => {
  throw new Error('Dynamic require of "' + x + '" is not supported');
};
var __export = (target, all) => {
  __markAsModule(target);
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toModule = (module2) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};

// src/index.ts
__export(exports, {
  default: () => solidReactivityPlugin
});
var import_helper_module_imports = __toModule(require("@babel/helper-module-imports"));
var t = __toModule(require("@babel/types"));
function getHookIdentifier(hooks, path, name) {
  const current = hooks.get(name);
  if (current) {
    return current;
  }
  const newID = (0, import_helper_module_imports.addNamed)(path, name, "solid-js");
  hooks.set(name, newID);
  return newID;
}
function signalSingleExpression(hooks, path, signalIdentifier, stateIdentifier) {
  const readIdentifier = path.scope.generateUidIdentifier(signalIdentifier.name);
  const writeIdentifier = path.scope.generateUidIdentifier(`set${signalIdentifier.name}`);
  const expr = t.variableDeclaration("const", [t.variableDeclarator(t.arrayPattern([
    readIdentifier,
    writeIdentifier
  ]), t.callExpression(getHookIdentifier(hooks, path, "createSignal"), [
    stateIdentifier,
    t.objectExpression([
      t.objectProperty(t.identifier("name"), t.stringLiteral(signalIdentifier.name))
    ])
  ]))]);
  path.insertAfter(expr);
  const parent = path.scope.path;
  if (parent) {
    parent.traverse({
      ObjectProperty(p) {
        if (p.scope !== path.scope && p.scope.hasOwnBinding(signalIdentifier.name)) {
          return;
        }
        if (p.node.shorthand && t.isIdentifier(p.node.key) && p.node.key.name === signalIdentifier.name && t.isIdentifier(p.node.value) && p.node.value.name === signalIdentifier.name) {
          p.replaceWith(t.objectProperty(signalIdentifier, t.callExpression(readIdentifier, [])));
        }
      },
      Identifier(p) {
        if (p.node.name !== signalIdentifier.name) {
          return;
        }
        if (p.scope !== path.scope && p.scope.hasOwnBinding(signalIdentifier.name)) {
          return;
        }
        if (t.isObjectMethod(p.parent) && p.parent.key === p.node) {
          return;
        }
        if (t.isObjectProperty(p.parent) && p.parent.key === p.node) {
          return;
        }
        if (t.isVariableDeclarator(p.parent) && p.parent.id === p.node) {
          return;
        }
        if (t.isArrayPattern(p.parent) && p.parent.elements.includes(p.node)) {
          return;
        }
        if (t.isArrowFunctionExpression(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (t.isFunctionExpression(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (t.isFunctionDeclaration(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (t.isLabeledStatement(p.parent) && p.parent.label === p.node) {
          return;
        }
        if (t.isMemberExpression(p.parent) && p.parent.property === p.node) {
          return;
        }
        if (t.isFunctionDeclaration(p.parent) && p.parent.id === p.node) {
          return;
        }
        if (t.isAssignmentPattern(p.parent) && p.parent.left === p.node && (t.isArrowFunctionExpression(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent) || t.isFunctionDeclaration(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent) || t.isFunctionExpression(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent))) {
          return;
        }
        p.replaceWith(t.callExpression(readIdentifier, []));
      },
      UpdateExpression(p) {
        if (p.scope !== path.scope && p.scope.hasOwnBinding(signalIdentifier.name)) {
          return;
        }
        if (t.isIdentifier(p.node.argument) && p.node.argument.name === signalIdentifier.name) {
          const param = p.scope.generateUidIdentifier("current");
          if (p.node.prefix) {
            p.replaceWith(t.callExpression(writeIdentifier, [
              t.arrowFunctionExpression([param], t.binaryExpression(p.node.operator === "++" ? "+" : "-", param, t.numericLiteral(1)))
            ]));
          } else {
            p.replaceWith(t.callExpression(t.arrowFunctionExpression([], t.blockStatement([
              t.variableDeclaration("const", [
                t.variableDeclarator(param, t.callExpression(readIdentifier, []))
              ]),
              t.expressionStatement(t.callExpression(writeIdentifier, [
                t.arrowFunctionExpression([], t.binaryExpression(p.node.operator === "++" ? "+" : "-", param, t.numericLiteral(1)))
              ])),
              t.returnStatement(param)
            ])), []));
          }
        }
      },
      AssignmentExpression(p) {
        if (p.scope !== path.scope && p.scope.hasOwnBinding(signalIdentifier.name)) {
          return;
        }
        const identifier2 = p.node.left;
        const expression = p.node.right;
        if (t.isIdentifier(identifier2) && identifier2.name === signalIdentifier.name) {
          if (p.node.operator === "=") {
            p.replaceWith(t.callExpression(writeIdentifier, [
              t.arrowFunctionExpression([], expression)
            ]));
          } else {
            const param = p.scope.generateUidIdentifier("current");
            p.replaceWith(t.callExpression(writeIdentifier, [
              t.arrowFunctionExpression([param], t.assignmentExpression(p.node.operator, param, expression))
            ]));
          }
        }
      }
    });
  }
}
function signalExpression(hooks, path, body) {
  if (t.isExpressionStatement(body)) {
    if (!t.isAssignmentExpression(body.expression)) {
      throw new Error("Expected assignment expression");
    }
    if (body.expression.operator !== "=") {
      throw new Error("Invalid assignment expression operator");
    }
    const leftExpr = body.expression.left;
    const rightExpr = body.expression.right;
    if (!t.isIdentifier(leftExpr)) {
      throw new Error("Expected identifier");
    }
    signalSingleExpression(hooks, path, leftExpr, rightExpr);
    path.remove();
  } else if (t.isVariableDeclaration(body)) {
    for (let i = body.declarations.length - 1; i >= 0; i -= 1) {
      const declarator = body.declarations[i];
      const leftExpr = declarator.id;
      const rightExpr = declarator.init;
      if (!t.isIdentifier(leftExpr)) {
        throw new Error("Expected identifier");
      }
      signalSingleExpression(hooks, path, leftExpr, rightExpr != null ? rightExpr : t.identifier("undefined"));
    }
    path.remove();
  } else {
    throw new Error("Expected assignment expression or variable declaration");
  }
}
function memoSingleExpression(hooks, path, memoIdentifier, stateIdentifier, replace = false) {
  const readIdentifier = path.scope.generateUidIdentifier(memoIdentifier.name);
  const expr = t.variableDeclaration("const", [t.variableDeclarator(readIdentifier, t.callExpression(getHookIdentifier(hooks, path, "createMemo"), [
    t.arrowFunctionExpression([], stateIdentifier),
    t.objectExpression([
      t.objectProperty(t.identifier("name"), t.stringLiteral(memoIdentifier.name))
    ])
  ]))]);
  if (replace) {
    path.replaceWith(expr);
  } else {
    path.insertAfter(expr);
  }
  const parent = path.scope.path;
  if (parent) {
    parent.traverse({
      ObjectProperty(p) {
        if (p.scope !== path.scope && p.scope.hasOwnBinding(memoIdentifier.name)) {
          return;
        }
        if (p.node.shorthand && t.isIdentifier(p.node.key) && p.node.key.name === memoIdentifier.name && t.isIdentifier(p.node.value) && p.node.value.name === memoIdentifier.name) {
          p.replaceWith(t.objectProperty(memoIdentifier, t.callExpression(readIdentifier, [])));
        }
      },
      Identifier(p) {
        if (p.node.name !== memoIdentifier.name) {
          return;
        }
        if (p.scope !== path.scope && p.scope.hasOwnBinding(memoIdentifier.name)) {
          return;
        }
        if (t.isObjectMethod(p.parent) && p.parent.key === p.node) {
          return;
        }
        if (t.isObjectProperty(p.parent) && p.parent.key === p.node) {
          return;
        }
        if (t.isVariableDeclarator(p.parent) && p.parent.id === p.node) {
          return;
        }
        if (t.isArrayPattern(p.parent) && p.parent.elements.includes(p.node)) {
          return;
        }
        if (t.isArrowFunctionExpression(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (t.isFunctionExpression(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (t.isFunctionDeclaration(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (t.isLabeledStatement(p.parent) && p.parent.label === p.node) {
          return;
        }
        if (t.isMemberExpression(p.parent) && p.parent.property === p.node) {
          return;
        }
        if (t.isFunctionDeclaration(p.parent) && p.parent.id === p.node) {
          return;
        }
        if (t.isAssignmentPattern(p.parent) && p.parent.left === p.node && (t.isArrowFunctionExpression(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent) || t.isFunctionDeclaration(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent) || t.isFunctionExpression(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent))) {
          return;
        }
        p.replaceWith(t.callExpression(readIdentifier, []));
      }
    });
  }
}
function memoExpression(hooks, path, body) {
  if (t.isExpressionStatement(body)) {
    if (t.isAssignmentExpression(body.expression)) {
      if (body.expression.operator !== "=") {
        throw new Error("Invalid assignment expression operator");
      }
      const leftExpr = body.expression.left;
      const rightExpr = body.expression.right;
      if (!t.isIdentifier(leftExpr)) {
        throw new Error("Expected identifier");
      }
      memoSingleExpression(hooks, path, leftExpr, rightExpr, true);
    } else {
      throw new Error("Expected assignment expression");
    }
  } else if (t.isVariableDeclaration(body)) {
    for (let i = body.declarations.length - 1; i >= 0; i -= 1) {
      const declarator = body.declarations[i];
      const leftExpr = declarator.id;
      const rightExpr = declarator.init;
      if (!t.isIdentifier(leftExpr)) {
        throw new Error("Expected identifier");
      }
      memoSingleExpression(hooks, path, leftExpr, rightExpr != null ? rightExpr : t.identifier("undefined"));
    }
    path.remove();
  } else {
    throw new Error("Expected assignment expression or variable declaration");
  }
}
function effectExpression(hooks, path, body) {
  let callback;
  if (t.isBlockStatement(body)) {
    callback = t.arrowFunctionExpression([], body);
  } else if (t.isExpressionStatement(body)) {
    callback = body.expression;
  } else {
    throw new Error("Expected arrow function or block expression");
  }
  path.replaceWith(t.callExpression(getHookIdentifier(hooks, path, "createEffect"), [
    callback
  ]));
}
function computedExpression(hooks, path, body) {
  let callback;
  if (t.isBlockStatement(body)) {
    callback = t.arrowFunctionExpression([], body);
  } else if (t.isExpressionStatement(body)) {
    callback = body.expression;
  } else {
    throw new Error("Expected arrow function or block expression");
  }
  path.replaceWith(t.callExpression(getHookIdentifier(hooks, path, "createComputed"), [
    callback
  ]));
}
function renderEffectExpression(hooks, path, body) {
  let callback;
  if (t.isBlockStatement(body)) {
    callback = t.arrowFunctionExpression([], body);
  } else if (t.isExpressionStatement(body)) {
    callback = body.expression;
  } else {
    throw new Error("Expected arrow function or block expression");
  }
  path.replaceWith(t.callExpression(getHookIdentifier(hooks, path, "createRenderEffect"), [
    callback
  ]));
}
function mountExpression(hooks, path, body) {
  let callback;
  if (t.isBlockStatement(body)) {
    callback = t.arrowFunctionExpression([], body);
  } else if (t.isExpressionStatement(body)) {
    callback = body.expression;
  } else {
    throw new Error("Expected arrow function or block expression");
  }
  path.replaceWith(t.callExpression(getHookIdentifier(hooks, path, "onMount"), [
    callback
  ]));
}
function cleanupExpression(hooks, path, body) {
  let callback;
  if (t.isBlockStatement(body)) {
    callback = t.arrowFunctionExpression([], body);
  } else if (t.isExpressionStatement(body)) {
    callback = body.expression;
  } else {
    throw new Error("Expected arrow function or block expression");
  }
  path.replaceWith(t.callExpression(getHookIdentifier(hooks, path, "onCleanup"), [
    callback
  ]));
}
function errorExpression(hooks, path, body) {
  let callback;
  if (t.isBlockStatement(body)) {
    callback = t.arrowFunctionExpression([], body);
  } else if (t.isExpressionStatement(body)) {
    callback = body.expression;
  } else {
    throw new Error("Expected arrow function or block expression");
  }
  path.replaceWith(t.callExpression(getHookIdentifier(hooks, path, "onError"), [
    callback
  ]));
}
function rootExpression(hooks, path, body) {
  let callback;
  if (t.isBlockStatement(body)) {
    callback = t.arrowFunctionExpression([], body);
  } else if (t.isExpressionStatement(body)) {
    callback = body.expression;
  } else {
    throw new Error("Expected arrow function or block expression");
  }
  path.replaceWith(t.callExpression(getHookIdentifier(hooks, path, "createRoot"), [
    callback
  ]));
}
function untrackExpression(hooks, path, body) {
  let callback;
  if (t.isBlockStatement(body)) {
    callback = t.arrowFunctionExpression([], body);
  } else if (t.isExpressionStatement(body)) {
    callback = body.expression;
  } else {
    throw new Error("Expected arrow function or block expression");
  }
  path.replaceWith(t.callExpression(getHookIdentifier(hooks, path, "untrack"), [
    callback
  ]));
}
function batchExpression(hooks, path, body) {
  let callback;
  if (t.isBlockStatement(body)) {
    callback = t.arrowFunctionExpression([], body);
  } else if (t.isExpressionStatement(body)) {
    callback = body.expression;
  } else {
    throw new Error("Expected arrow function or block expression");
  }
  path.replaceWith(t.callExpression(getHookIdentifier(hooks, path, "batch"), [
    callback
  ]));
}
function solidReactivityPlugin() {
  return {
    pre() {
      this.hooks = new Map();
    },
    visitor: {
      LabeledStatement(path, state) {
        const { label, body } = path.node;
        switch (label.name) {
          case "signal":
            signalExpression(state.hooks, path, body);
            break;
          case "effect":
            effectExpression(state.hooks, path, body);
            break;
          case "computed":
            computedExpression(state.hooks, path, body);
            break;
          case "renderEffect":
            renderEffectExpression(state.hooks, path, body);
            break;
          case "memo":
            memoExpression(state.hooks, path, body);
            break;
          case "mount":
            mountExpression(state.hooks, path, body);
            break;
          case "cleanup":
            cleanupExpression(state.hooks, path, body);
            break;
          case "error":
            errorExpression(state.hooks, path, body);
            break;
          case "untrack":
            untrackExpression(state.hooks, path, body);
            break;
          case "batch":
            batchExpression(state.hooks, path, body);
            break;
          case "root":
            rootExpression(state.hooks, path, body);
            break;
          default:
            break;
        }
      }
    }
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
//# sourceMappingURL=index.js.map
